# Verification

Once a model has been syntaxically checked, TTool can perform verification on the model.

## Formal and informal verification

Verification can be formal, i.e. the model is first transformed into a mathematically defined specification before the latter is verified. Informal verification relates to the simulation or the execution of the system, i.e. the generation of one possible execution trace. On the contrary, formal verification intends to explore all the execution possibilities.

## Safety, security and performance verification

Techniques used to verify safety, security and performance properties are different.

- Safety verification is usually performed using model-checking techniques.

- [Security verification](file://securityverification.md) relies on formal verification techniques to check for confidentiality, integrity and authenticity properties.

- Performance properties can be checked with simulation techniques.








